#include <ClickEncoder.h>
#include <TimerOne.h>
#include <LCD5110_Graph.h>

LCD5110 lcd(8,9,10,12,11);
extern unsigned char SmallFont[];
extern unsigned char TinyFont[];

ClickEncoder *encoder;
int16_t last, value;

void timerIsr() {
  encoder->service();
}

void setup() {
  
  lcd.InitLCD();
  lcd.setFont(TinyFont);
  lcd.print("Rotary Endcoder",CENTER,0);
  lcd.print("DEMO",CENTER,20);
  lcd.update();
  delay(2000);
  lcd.setFont(SmallFont);
  encoder = new ClickEncoder(A1, A0, A2);
  encoder->setAccelerationEnabled(false);

  Timer1.initialize(1000);
  Timer1.attachInterrupt(timerIsr); 
  last = -1;
}

void loop() {  
  int encoderValue;
  int encoderPosition;
  lcd.setFont(SmallFont);
  char encoderValueArray[3]; 
  char encoderPositionArray[3];
  
  value += encoder->getValue();
  
  if (value/4 != last) {
    encoderValue = value/4;
    encoderPosition = encoderValue%20;
      
    last = encoderValue;
    
    lcd.clrScr();
    lcd.print("Value: ",LEFT,0);
    dtostrf(encoderValue, 3, 0, encoderValueArray);
    lcd.print(encoderValueArray,LEFT+55,0);
    
    dtostrf(encoderPosition, 3, 0, encoderPositionArray);
    lcd.print("Position:",LEFT,20);
    
    if(encoderPosition <0)
      encoderPosition = -encoderPosition;
    lcd.print(encoderPositionArray,LEFT+55,20);

    //Serial.print("\n");
    lcd.update();
  }
  
  ClickEncoder::Button b = encoder->getButton();
  if (b != ClickEncoder::Open) {
    #define VERBOSECASE(label) case label:lcd.setFont(TinyFont);lcd.print(#label,CENTER,40);lcd.update(); break;
    switch (b) {
      VERBOSECASE(ClickEncoder::Pressed);
      VERBOSECASE(ClickEncoder::Held)
      VERBOSECASE(ClickEncoder::Released)
      VERBOSECASE(ClickEncoder::Clicked)
      case ClickEncoder::DoubleClicked:
          encoder->setAccelerationEnabled(!encoder->getAccelerationEnabled());
        break;
    }
  }    
}
